//*********************************
//ģ:sd.c
//:2011-05-10
//:LPC2103SDĵײļ
//:
//*********************************

//**********ͷļ***************
#include "config.h"
#include "LPC2103.h"
#include "uart.h"
#include "sd.h"
#include "fat16.h"

//************ȫֱ*****************
UINT8 rad=11;                     
UINT8 r2=11;
UINT8 temp = 0xfd;
//ڱŻϴһЩ⣬һЩҪóΪ
//ȫֱʱ* is set but never used  debug
 //ı

//*********************************
//SPI_Init
//SPIӿŹѡ
//룺
//
//ú
//
//*********************************
void SPI_Init(void)
{
 PINSEL0 |= 0x1500;
 PINSEL1 |= 0x0000;
 IODIR |=1<<18; //P0.18ѡΪ
 SD_CS_1;
}

//*********************************
//SPI_LowSpeed
//SPIĵģʽ
//룺
//
//ú
//SDλʼʱӦѡ˺
//      ģʽSPIƵĲͬ
//*********************************
void SPI_LowSpeed(void)
{
  S0SPCCR = 0xd2;
  S0SPCR = 0<<3|1<<4|1<<5|0<<6|0<<7;  
}

//*********************************
//SPI_HighSpeed
//SPIĸģʽ
//룺
//
//ú
//ڶSDждʱӦѡ˺
//      ģʽSPIƵĲͬ
//*********************************
void SPI_HighSpeed(void)
{
  S0SPCCR = 0x08;
  S0SPCR = 0<<3|1<<4|1<<5|0<<6|0<<7;
}

//*********************************
//SD_write_byte
//SDдֽڵĺ
//룺data-SDдֽ
//S0SPDR-SDصֽ
//ú
//
//*********************************

UINT8 SD_write_byte(UINT8 data)
{
  S0SPDR = data;
  while((S0SPSR&0x80)== 0);
  return (S0SPDR);
}

//*********************************
//SD_write_command
//SDдĺ
//룺command- address-ַ
//r1-дSDӦֽ
//ú
//          SD_write_byte(data)
//
//*********************************
UINT8 SD_write_command(UINT8 command,UINT32 address)
{
  UINT8 temp=0;
  UINT8 r1=11;
  SD_write_byte(0xff);
  SD_CS_0;//CSƬѡ
  SD_write_byte(command|0x40);
  SD_write_byte((address&0xff000000)>>24);
  SD_write_byte((address&0x00ff0000)>>16);
  SD_write_byte((address&0x0000ff00)>>8);
  SD_write_byte(0x00);   
  r1=SD_write_byte(0x95);
  while((r1=SD_write_byte(0xff))== 0xff)
    {     
      if((temp++)>=10)
      {
        //UART0_PutString("write command faild\n");
      }
      
    }
  SD_CS_1;//CSƬѡ
  return (r1);
}
         
//*********************************
//SD_reset
//SDλʼ
//룺
//0x00-λʼɹ 0x01-λʼʧ
//ú
//          SD_write_byte(data)
//          SD_write_command(command,address)
//
//*********************************
UINT8 SD_reset(void)
{
  UINT8 i;
  UINT8 r1=3;
  UINT16 temp=0;
  rad = 11;
  SD_CS_1;
  SPI_LowSpeed();//SPIģʽ
//**********SDλ0***************
  while(r1!=0x01)//жǷ񷵻0x01ɹλ
    {
      for(i=0;i<100;i++)//********************ȴ74
      SD_write_byte(0xff);//*************ʱ      
       r1 = SD_write_command(0,0);//д0
           rad = SD_write_byte(0xff);
      if(temp++>10)
      {
         //UART0_PutString("SD reset cmd0  faild\n");
          return 0x01;
      }
    }
    r1 = SD_write_byte(0xff);

  if (r1==0x01)
  {
    //UART0_PutString("cmd0 ok\n");
  }
  temp = 0;
//**********SDʼ1*************** 
  r2 = SD_write_command(1,0);//д1  
  while(r2!=0x00)//жǷ񷵻0x00ɹʼ
    r2 = SD_write_command(1,0);
  if(r2==0x00)
  {
    //UART0_PutString("cmd1 ok\n");
  }
  SD_CS_1;//Ƭѡź CS=1
  SPI_HighSpeed();//ģʽ
  SD_write_byte(0xff);//SD׷8ʱ
  return 0x00; 
}

//*********************************
//SD_writesector
//SDдĺ
//룺sector-ַ *buffer-ݻ
//0x00-дɹ 0x01-дʧ
//ú
//          SD_write_byte(data)
//          SD_write_command(command,address)
//
//*********************************
UINT8 SD_writesector(UINT32 sector,UINT8 *buffer)
{
  UINT16 i;
  UINT8 temp=0;
  UINT8 r1 = 0xfd;
  SD_write_byte(0xff);
  SD_CS_0;
  r1 = SD_write_command(24,sector<<9);
  while(r1!=0x00)
  {
    r1 = SD_write_byte(0xff);
    if((temp++)>10)
    {
      //UART0_PutString("cmd24 faild\n");
        return 0x01;
    }
  }
  if(r1 ==0x00)
    //UART0_PutString("cmd24 ok\n");
  for(i=0;i<15;i++) SD_write_byte(0xff);//ȴ100ʱ
  SD_CS_0;
  SD_write_byte(0xfe);//д0xfe,ʾҪʼд512ֽ
  for(i=0;i<512;i++)
  {
    SD_write_byte(*buffer);
    buffer++;
  }
  SD_write_byte(0xff);
  r1 = SD_write_byte(0xff);
  while((r1&0x1f)!=0x05)
  {
    r1 = SD_write_byte(0xff);
  }
  if(r1 == 0x05)
    //UART0_PutString("XXX00101 ok\n");
  r2 = SD_write_byte(0xff);
  while((r2=SD_write_byte(0xff))!=0xff);
  SD_CS_1;
  return 0x00;  
}

//*********************************
//SD_readsector
//SDĺ
//룺sector-ַ *buffer-ݻ
//0x00-ɹ 0x01-ʧ
//ú
//          SD_write_byte(data)
//          SD_write_command(command,address)
//ݴ*buffer
//*********************************
UINT8 SD_readsector(UINT32 sector,UINT8 *buffer)
{
  UINT16 i;
  UINT8 r1 = 0xfd;
  volatile UINT8 xp = 0xfd;
  xp = SD_write_byte(0xff);
  SD_CS_0;
  r1 = SD_write_command(17,sector<<9);
  while(r1 != 0x00)
  {
   r1 = SD_write_byte(0xff);
   if((temp++)>10)
   {
      //UART0_PutString("SD_readsector wait 0x00 faild\n");
    return 0x01;
   }
  }
  temp = SD_write_byte(0xff);
  SD_CS_0;//Ƭѡź CS=0
  temp = 0;
  r1 = SD_write_byte(0xff);
  while(r1 != 0xfe)
  {
    r1 = SD_write_byte(0xff);
    if((temp++)>200)
    {
     //UART0_PutString("SD_readsector wait 0xfe faild\n");
      return 0x01;
    }
  }
  if(r1 == 0xfe)
  {
     //UART0_PutString("begin receive 512 bytes\n");
  }
  for(i=0;i<512;i++)
  {
    *buffer = SD_write_byte(0xff);
    buffer++;
  }
  SD_write_byte(0xff);
  SD_write_byte(0xff);
  SD_CS_1;
  SD_write_byte(0xff);
  return 0x00;
}
